/*********************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2017-2018, XinJiang University. All right reserved
 *
 * ļ		:	Sys_Basic.h
 *  		:	ϵͳ
 *
 * 汾			:	V3.3.0
 * 			:	־
 * 			:	2017-10-22
 * 
 * ȫ֮Ȩ½ѧУȨǼǱ2018R11L423999
 * δȨȨκελ͸˲ý³ҵӯ;
 * ޸Ĵ˳뱣Ȩóע
**********************************************************************************/
#ifndef _SYS_BASIC_H_
#define	_SYS_BASIC_H_

//ADC
#define	ADC_P10			0x01	//IO Px.0
#define	ADC_P11			0x02	//IO Px.1
#define	ADC_P12			0x04	//IO Px.2
#define	ADC_P13			0x08	//IO Px.3
#define	ADC_P14			0x10	//IO Px.4
#define	ADC_P15			0x20	//IO Px.5
#define	ADC_P16			0x40	//IO Px.6
#define	ADC_P17			0x80	//IO Px.7
#define	ADC_P1_All	0xFF	//IO

#define ADC_90T				(3<<5)
#define ADC_180T			(2<<5)
#define ADC_360T			(1<<5)
#define ADC_540T			0
#define	DATA_SUM			8			//ADCֵ
#define	DATA_DIV			3
#define ADC_FLAG			(1<<4)	//0
#define ADC_START			(1<<3)	//Զ0
#define	BangGap_Addr	(0xEFF7)	//BandGapѹֽROMλ

//EEPROM
#define   MOVC_ShiftAddress    	0x2000

//
#define 	BEEP_TIME							500

//״̬öٶ壬0Ϊ1Ϊߣ2Ϊ
typedef enum
{
    NORMAL  	=   0,         
    SLEEPING 	=   1,        
		STANDBY		=		2
} IRON_STATUS_e;

//ʹ״̬ö٣ʹΪ1Ϊ0
typedef enum
{
    FREE  	=   0,         
    USING 	=   1,        
} IRONUSE_STATUS_e;

//ʹ״̬ö٣ʹΪ1Ϊ0
typedef enum
{
    Disable  	=   0,         
    Enable 		=   1,        
} RUN_STATUS_e;

//ʹṹ
typedef struct
{
	IRONUSE_STATUS_e	Handle;				//ֱʹΪUSINGΪFREE
	IRONUSE_STATUS_e	Coder;				//ʹΪUSINGΪFREE
}IRONUSE_STATUS_s;

//ʱ
typedef struct
{
	unsigned int   mSec;				//
	unsigned char	Sec;				//
	unsigned char	Min;				//ּ
}TIMER_s;

//PWMнṹ
typedef struct
{
	int  						Duty;				//pwmռձ
	RUN_STATUS_e 		Run;				//pwmб־λ
}PWM_s;

extern IRON_STATUS_e			IronStateFlag;		//״̬־λ
extern IRONUSE_STATUS_s		IronUse_Status;		//ʹ״̬־λ
extern TIMER_s						Timer;
extern PWM_s							PWM;


extern void 						Delay_ms(unsigned char ms);
extern void 						EEPROM_read_n(unsigned int EE_address,unsigned char *DataAddress,unsigned int number);
extern void 						EEPROM_write_n(unsigned int EE_address,unsigned char *DataAddress,unsigned int number);
extern void						EEPROM_SectorErase(unsigned int EE_address);
extern unsigned int		Get_ADC10bitResult(unsigned char channel);
extern void 						Delay10us(unsigned char us);		//@24.000MHz
void SendChar(unsigned char dat);


#endif