/*********************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2017, XinJiang University
 * All rights reserved.
 *
 * ļ		:	Sys_Control.c
 *  		:	¶ȿ
 *
 * 汾			:	V3.2.0
 * 			:	־
 * 			:	2017-10-19
 * 
 * ȫ֮Ȩ½ѧУȨǼǱ2018R11L423999
 * δȨȨκελ͸˲ý³ҵӯ;
 * ޸Ĵ˳뱣Ȩóע
**********************************************************************************/
#include "config.h"

PID_s		IronPID = {3.0f,0.1f,0.1f,0.0f,{0.0f,0.0f},0.0f,0.0f,0.0f};

/************************************************************
 * 		:	IronTempControl
 * ˵	:	PID¶ȣPֶΣI롢
 *
 * 	:	tempĿ¶
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-22
*************************************************************/	
void IronTempControl(unsigned int temp)
{
	//趨¶
	IronPID.Set = temp;
	EA=0;//stop other interrupt
	//¶
	if(FtyModeFlag)//ڹģʽУ׼ͷŲ
	{
		IronTemp.Feedback = GetIronTemp(FAC_DATA_Table.Adjust_s.Iron);
	}
	else//ͨģʽѡͷŲ
	{
		IronTemp.Feedback = GetIronTemp(MENU_DATA_Table.Other_s.Heater_Tip);
	}
	EA=1;
	IronPID.Feedback = IronTemp.Feedback;
	
  //
  IronPID.Delta[0] = IronPID.Set - IronPID.Feedback + STEADY_ERR; 
  
	//ַ
	if(IronPID.Delta[0] > 20.0f)
	{
		IronPID.kP = (float)FAC_DATA_Table.PID[0] / 4.0f;
		IronPID.kI = (float)FAC_DATA_Table.PID[1] / 200.0f;
		IronPID.kD = (float)FAC_DATA_Table.PID[2] / 100.0f;
		IronPID.Integration=0;
	}
	else if(IronPID.Delta[0]<-10.0f)
	{
		IronPID.kP = (float)FAC_DATA_Table.PID[0] / 4.0f;
		IronPID.kI = (float)FAC_DATA_Table.PID[1] / 2000.0f;
		IronPID.kD = (float)FAC_DATA_Table.PID[2] / 100.0f;
		IronPID.Integration=0;
	}
	else
	{
		IronPID.kP = (float)FAC_DATA_Table.PID[0] / 10.0f;
		IronPID.kI = (float)FAC_DATA_Table.PID[1] / 100.0f;
		IronPID.kD = (float)FAC_DATA_Table.PID[2] / 100.0f;
	}
	
  //PID
	if(IronPID.Integration > 100)//ֳʱֻۼƸĻ
	{
		if(IronPID.Delta[0] < 0)
		{
			IronPID.Integration += IronPID.kI * IronPID.Delta[0];
		}
	}
	else if(IronPID.Integration < -10)//ֳʱֻۼĻ
	{
		if(IronPID.Delta[0] > 0)
		{
			IronPID.Integration += IronPID.kI * IronPID.Delta[0];
		}
	}
	else
	{
		IronPID.Integration += IronPID.kI * IronPID.Delta[0];
	}
	
	
	IronPID.Out = IronPID.kP * IronPID.Delta[0] + IronPID.kD * (IronPID.Delta[0] - IronPID.Delta[1]) + IronPID.Integration;
  
	//趨¶ȴ50С¶Ȳſ
	if(IronPID.Set > 50 && IronPID.Set <= MENU_DATA_Table.Temp_s.Max_Temp && ((unsigned char)GetVoltage()>=FAC_DATA_Table.Other_s.Lim_Voltage))
	{
		//255ֱӵ255
		if(IronPID.Out > 97.0f)// changed from 255
		{
			PWM.Run = Enable;
			PWM.Duty = 97u;
		}
		//0
		else if(IronPID.Out >= 0.1f)
		{
			PWM.Run = Enable;
			PWM.Duty = (unsigned char)IronPID.Out;
		}
		//
		else
		{
			PWM.Duty = 0;
			IronPID.Out = 0;
			PWM.Run = Disable;
			//IRON = 0;
		}
	}
	//趨¶С50¶ȣ
	else
	{
		PWM.Duty = 0;
		IronPID.Out = 0;
		PWM.Run = Disable;
		//IRON = 0;
	}

	//
  IronPID.Delta[1] = IronPID.Delta[0];
}
