/*********************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2017-2018, XinJiang University. All right reserved
 *
 * ļ		:	Sys_Init.c
 *  		:	ϵͳʼ
 *
 * 汾			:	V3.3.3
 * 			:	־
 * 			:	2017-10-22
 * 
 * ȫ֮Ȩ½ѧУȨǼǱ2018R11L423999
 * δȨȨκελ͸˲ý³ҵӯ;
 * ޸Ĵ˳뱣Ȩóע
**********************************************************************************/
#include "config.h"

/************************************************************
 * 		:	Exti_Init
 * ˵	:	ʹⲿж4жϣ
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
void Exti_Init(void)
{
	INT_CLKO |= 0x40;           //(EX4 = 1)ʹINT4½ж
}

/************************************************************
 * 		:	ADC_Init
 * ˵	:	ʼADC3,57ͨʹADCԴ
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
void ADC_Init(void)
{
	#ifdef WB_LCD	
		P1ASF    	 = 	ADC_P11|ADC_P14|ADC_P16;
	#else
		P1ASF    	 = 	ADC_P13|ADC_P15|ADC_P17;	
	#endif	
	ADC_CONTR  = 	(ADC_CONTR & ~ADC_90T) | ADC_360T;//ADCٶADC_180T
	ADC_CONTR |= 	0x80;															//ADCENABLE
	PCON2 		|= 	(1<<5);														//ADC,	ADC_RES_H2L8
	PADC 			 = 	0;																//ȼPolityLow
	EADC 			 = 	0;																//жDISABLE
	ADC_CONTR |= 	0x80;															//ADCԴENABLE
}


/************************************************************
 * 		:	Timer_Init
 * ˵	:	ʼʱ0,1,2ʹж
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
void Timer_Init(void)
{			
	//ʱ0,16λԶװأ12T25usڷPWM
	AUXR |= 0x80;		//ʱʱ1Tģʽ
	TMOD &= 0xF0;		//öʱģʽ
	TL0 	= 0xA8;		//öʱֵ
	TH0 	= 0xFD;		//öʱֵ
	TF0 	= 0;			//TF0־
	TR0 	= 1;			//ʱ0ʼʱ
	
	//ʱ1,16λԶװأ1T1ms¶ȿƺߴʱ
	AUXR |= 0x40;		//ʱʱ1Tģʽ
	TMOD &= 0x0F;		//öʱģʽ
	TL1 	= 0x40;		//öʱֵ
	TH1 	= 0xA2;		//öʱֵ
	TF1 	= 0;			//TF1־
	TR1 	= 1;			//ʱ1ʼʱ
	
		
	//ʱж
	ET0 	= 	1;
	ET1 	= 	1;
}


/************************************************************
 * 		:	ParaInit
 * ˵	:	EEPROMǰ5ֽΪFFEEPROM
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
void ParaInit(void)
{
	unsigned char temp[5],i;
	
	//ȶEEPROMǰλ
	EEPROM_read_n(0x0,(unsigned char *)&temp,sizeof(temp));
	for(i=0;i<5;i++)
	{
		temp[0] &= temp[i];
	}
	
	//OXFFôˢEEPROMĻصʱֻҪѡνEEPROMȫΪFFĻͿʵˢEEPROM
	if(temp[0] == 0xff)
	{
		EEPROM_SectorErase(0x0);
		EEPROM_SectorErase(0x200);
		EEPROM_write_n(0x0,(unsigned char *)&MENU_DATA_Table,sizeof(MENU_DATA_Table));
		EEPROM_write_n(0x200,(unsigned char *)&FAC_DATA_Table,sizeof(FAC_DATA_Table));
	}
	
	EEPROM_read_n(0x0,(unsigned char *)&MENU_DATA_Table,sizeof(MENU_DATA_Table));
	EEPROM_read_n(0x200,(unsigned char *)&FAC_DATA_Table,sizeof(FAC_DATA_Table));
	
	//Ĭ¶ȲΪ0Ĭ¶趨Ϊ¶
	if(MENU_DATA_Table.Temp_s.Default_Temp != 0)
	{
		IronTemp.Set = MENU_DATA_Table.Temp_s.Default_Temp;
	}
	if(MENU_DATA_Table.Temp_s.Default_CH != 0)
	{
		IronTemp.Chn = MENU_DATA_Table.Temp_s.Default_CH;
	}
	//Ĭ¶Ϊ0ϴ¶趨Ϊ¶
	if(MENU_DATA_Table.Temp_s.Default_Temp == 0)
	{
		IronTemp.Set = MENU_DATA_Table.Temp_s.Last_Temp;
	}
	if(MENU_DATA_Table.Temp_s.Default_CH == 0)
	{
		IronTemp.Chn = MENU_DATA_Table.Temp_s.Last_CH;
	}
	
}


/************************************************************
 * 		:	Sys_Init
 * ˵	:	Ϻʼϵͳ
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	P03Ϊ
 * 	:	־
 * 			:	2017-10-32
*************************************************************/	
void Sys_Init(void)

{
	//PWMENADCӿڸ裬SLEEP
	//M1,M0: 00 pullup,01 PP, 10 HZ, 11 OD
	
	#ifdef	WB_LCD
		P2M0 = 0x08;
		P2M1 = 0x00;
		P1M0 = 0x09;
		P1M1 = 0x00;
	#else
		P1M0=0x03;//00000011
		P1M1=0xe8;//10101000
		P0M0 = 0x08;//00001000
		P0M1 = 0x00;//00000000
	#endif
	
	//ʼΪر
	IRON = 0;
	PWM_EN = 0;
	
	#if SCREEN == 2
		LED_ON;//LCD
	#endif

	//ȶEEPROM
	EA = 0;
  ParaInit();
	EA = 1;
	
	//UIʼ
	user_menu_init();
	//ʼ
	Beep(MENU_DATA_Table.Other_s.Beep_Volume);
	ADC_Init();
	Timer_Init();
	Exti_Init();
	//Uart_Init();
	
	//LOGO
	#ifdef DRAW_LOGO
		Draw_LOGO(Logo);
		Delay_ms(200);Delay_ms(200);
		Delay_ms(200);Delay_ms(200);
		Delay_ms(200);Delay_ms(200);
	#endif
	OLED_CLS();
}
