/*********************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2017-2018, XinJiang University. All right reserved
 *
 * ļ		:	Sys_Sample.c
 *  		:	ϵͳ
 *
 * 汾			:	V3.3.3
 * 			:	־
 * 			:	2017-10-22
 * 
 * ȫ֮Ȩ½ѧУȨǼǱ2018R11L423999
 * δȨȨκελ͸˲ý³ҵӯ;
 * ޸Ĵ˳뱣Ȩóע
**********************************************************************************/
#include "config.h"

float 				RoomTemp = 25.0f;
float 				VCCVoltage = 0.0f;



/************************************************************
 * 		:	mid_filter
 * ˵	:	ֵ˲ȥֵСֵƽ¶Ȳ˲
 *
 * 	:	
 * 	:	
 *
 * ޸ļ¼	:	һα༭
 * 	:	BEAT
 * 			:	2017-10-18
*************************************************************/	
static u16 mid_filter(void)
{
	u16	sum = 0;
	u8 temp;
	for(temp = 0; temp < NUM; temp++)
	{
		//sum += lim_filter(Get_ADC10bitResult(ADC_IRON),20);
		sum += Get_ADC10bitResult(ADC_IRON);
	}														
	return(sum >> DIV);  													//ƴ
}



/************************************************************
 * 		:	GetVoltage
 * ˵	:	ADC24Vѹ
 *
 * 	:	
 * 	:	24vѹ
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
float GetVoltage(void)
{
	return (float)Get_ADC10bitResult(ADC_VCC) / 5550.0f * (float)FAC_DATA_Table.Adjust_s.Voltage;
}


//NTC¶ȱΪ-10~50ӦADCֵ
unsigned int code NTCTAB[61] =
{
	324, 318, 312, 306, 300, 294, 288, 282, 276, 269, 263, 257, 251, 245, 238, 232, 226, 220, 214, 209, 
	203, 197, 192, 186, 181, 175, 170, 165, 160, 155, 150, 146, 141, 137, 132, 128, 124, 120, 116, 112, 
	108, 105, 101,  98,  95,  92,  89,  86,  83,  80,  77,  75,  72,  70,  67,  65,  63,  61,  59,  57,
	55 
};
/************************************************************
 * 		:	GetRoomTemp
 * ˵	:	£ַ
 *
 * 	:	
 * 	:	ֵfloat
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
float GetRoomTemp(void)
{
	u16 temp=0;
	unsigned char det = 60,head = 0,tail = 60,mid = 0;
	
	temp = Get_ADC10bitResult(ADC_ROOMTEMP);	 //slw modified from temp = Get_ADC10bitResult(ADC_ROOMTEMP)

	//С-10ֱӵ
	if(temp >= NTCTAB[head])
	{
		return -10.0f;
	}
	//50ֱӵ
	else if(temp <= NTCTAB[tail])
	{
		return 50.0f;
	}
	//򣬶ַ
	else
	{
		//ͷ-β = 1 ѭ
		while(det > 1)
		{
			//ֵ
			mid = (head + tail)/2;
			//ǡΪֵ ֱreturn
			if(temp > (NTCTAB[mid]))
			{
				tail = mid;
			}
			else
			{
				head = mid;
			}
			det = tail - head;
		}
		return ((float)(head-10)  / 100.0f * (float)FAC_DATA_Table.Adjust_s.Temp);
	}
}


/************************************************************
 * 		:	GetIronTemp
 * ˵	:	¶ȣ
 *
 * 	:	numͷţ1-4
 * 	:	¶ȣ޷
 *
 * ޸ļ¼	:	һα༭
 * 	:	־
 * 			:	2017-10-18
*************************************************************/	
//unsigned int GetIronTemp(unsigned char num)
float GetIronTemp(unsigned char num)
{
	u16 temp=0;
	unsigned char det = 6,head = 0,tail = 6,mid = 0,i=0;
	
	//
	PWM.Run = Disable;
	IRON = 0;
	
	temp = mid_filter();
	
	//¶ȵڱֵʱ
	if(temp < FAC_DATA_Table.Heater_Tip[num-1][tail])
	{
		//ͷ-β = 1 ѭ
		while(det > 1)
		{
			//ֵ
			mid = (head + tail) / 2;

			if(temp < (FAC_DATA_Table.Heater_Tip[num-1][mid]))
			{
				tail = mid;
			}
			else
			{
				head = mid;
			}
			det = tail - head;
		}
		//Բֵ(˲)
		return RoomTemp + 100 * head  + ((temp - FAC_DATA_Table.Heater_Tip[num-1][head]) * 100 / (FAC_DATA_Table.Heater_Tip[num-1][tail] - FAC_DATA_Table.Heater_Tip[num-1][head]));
	}
	//ڱֵʱֱӷ599.0f
	else
	{
		return 599.0f;
	}

}